#! /usr/bin/env python

import CORBA
import PortableServer
from PortableServer__POA import ServantActivator
import forwardRequestBug
import forwardRequestBug__POA
import sys

class Some(forwardRequestBug__POA.Some):
  pass

class TestActivator(ServantActivator):
  
  def __init__(self, rootPOA):
    self.rootPOA = rootPOA
    self.rootMgr = self.rootPOA._get_the_POAManager()
  
  def activate (self, name):
    self.name = name
    policy = [self.rootPOA.create_request_processing_policy(PortableServer.USE_SERVANT_MANAGER)]
    self.rootMgr.activate()
    self.poa = self.rootPOA.create_POA(name, self.rootMgr, policy)
    self.ref = self._this()
    self.poa.set_servant_manager(self.ref)
    self.realServant = Some()
    self.rootPOA.activate_object(self.realServant)
    self.realRef =  self.rootPOA.servant_to_reference(self.realServant)
    return self.poa.create_reference("no")

  def incarnate (self, oid, poa):
    raise PortableServer.ForwardRequest(self.realRef)
  
  def etherealize (self, oide, poa, servant, cleanup_in_progress, remaining_activation):
    pass

def main():
  orb = CORBA.ORB_init(sys.argv,  CORBA.ORB_ID)
  poa = orb.resolve_initial_references("RootPOA")
  testActivator = TestActivator (poa)
  ref = testActivator.activate("noName")
  narrow = ref._narrow(forwardRequestBug.Some)
    
main()
